<?php

namespace Imagine;

class Draw {

    // http://php.net/imageline
    public static function line($image, $x1, $y1, $x2, $y2, $colors, $thickness = 1) {
        if ( $thickness == 1 ) {
            return \imageline($image, $x1, $y1, $x2, $y2, $colors['fore'] );
        }

        $t = $thickness / 2 - 0.5;
        if ($x1 == $x2 || $y1 == $y2) {
            return \imagefilledrectangle($image, round(min($x1, $x2) - $t), round(min($y1, $y2) - $t), round(max($x1, $x2) + $t), round(max($y1, $y2) + $t), $colors['fore']);
        }

        $k = ($y2 - $y1) / ($x2 - $x1); //y = kx + q
        $a = $t / sqrt(1 + pow($k, 2));

        $points = [
            round($x1 - (1+$k)*$a), round($y1 + (1-$k)*$a),
            round($x1 - (1-$k)*$a), round($y1 - (1+$k)*$a),
            round($x2 + (1+$k)*$a), round($y2 - (1-$k)*$a),
            round($x2 + (1-$k)*$a), round($y2 + (1+$k)*$a)
        ];

        \imagefilledpolygon($image, $points, 4, $color);
        return \imagepolygon($image, $points, 4, $color);
    }

}
