<?php

namespace Imagine;

class Layer extends Canvas {

    public string $name;

    public int $order;

    public int $position;

    public function moveUp() {
        $this->order = ($this->order-- === 0) ? 0 : $this->order;

        return $this;
    }

    public function moveDown() {
        $this->order++;

        return $this;
    }

    /* Setting current layer on top, based on every other layers */
    public function onTop() {
        $max = 0;

        foreach ($this->parent->layers() as $value) {
            $max = max($max, $value->order());
        }

        $this->order = $max + 1;

        return $this;
    }

    public function order($set = null) {
        return $set ? ($this->order = $set) : $this->order;
    }

}
